<?php

/*
 * Copyright by SoftCreatR Media.
 *
 * License: https://www.softcreatr.com/license-terms
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 *
 * The above copyright notice and this disclaimer notice shall be included in all
 * copies or substantial portions of the Software.
 */

namespace wcf\system\event\listener;

use wcf\data\option\Option;
use wcf\data\user\avatar\ScDefaultAvatar;

class ScDefaultAvatarListener implements IParameterizedEventListener
{
    /**
     * @inheritDoc
     */
    public function execute($eventObj, $className, $eventName, array &$parameters)
    {
        $newOption = 'custom';

        switch ($className) {
            case 'wcf\system\option\OptionHandler':
                /** @var Option $option */
                $option = $eventObj->cachedOptions['avatar_default_type'];

                if ($option !== null) {
                    $option->modifySelectOptions($option->selectOptions . "\n{$newOption}:wcf.acp.option.{$option->optionName}.{$newOption}");
                    $option->modifyEnableOptions($option->enableOptions . "\n{$newOption}:avatar_default_image");

                    $eventObj->cachedOptions[$option->optionName] = $option;
                }
                break;

            case 'wcf\data\user\UserProfile':
                if (AVATAR_DEFAULT_TYPE === $newOption) {
                    $parameters['avatar'] = new ScDefaultAvatar();
                }
                break;
        }
    }
}
