<?php

/*
 * Copyright by SoftCreatR Media.
 *
 * License: https://www.softcreatr.com/license-terms
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 *
 * The above copyright notice and this disclaimer notice shall be included in all
 * copies or substantial portions of the Software.
 */

namespace wcf\system\option;

use wcf\data\option\Option;
use wcf\system\application\ApplicationHandler;
use wcf\system\exception\SystemException;
use wcf\system\upload\ScDefaultAvatarImageUploadFileValidationStrategy;
use wcf\system\WCF;

use function implode;
use function time;

class ScDefaultAvatarImageOptionType extends FileOptionType
{
    /**
     * @inheritDoc
     *
     * @throws SystemException
     */
    public function getFormElement(Option $option, $value)
    {
        $imagePath = null;
        $wcf = ApplicationHandler::getInstance()->getApplicationByID(1);

        if ($value && null !== $wcf) {
            $imagePath = $wcf->getPageURL() . $value . '?v=' . time();
        }

        WCF::getTPL()->assign([
            'option' => $option,
            'value' => $value,
            'imagePath' => $imagePath,
            'allowedExtensions' => implode(', ', ScDefaultAvatarImageUploadFileValidationStrategy::$allowedExtensions)
        ]);

        return WCF::getTPL()->fetch('scDefaultAvatarImageOptionType');
    }
}
